EnableExplicit



#soc = SizeOf(character)

Global parseFileError.s
Global NewList parseFile_includes.s()




Macro findhere(s, off_2=0, l=16)
  ( 0 Or 1=FindString(PeekS(*mem+off+off_2,l), s ,1) )
EndMacro


Macro NEWLINE
  #CRLF$ + indent
EndMacro


Macro RETURN_(s="")
  call-1
  ProcedureReturn s
EndMacro


Macro shipnext(n=1)
  temp_.l=n
  While temp_
    ;Debug Chr(c)
    If temp_ > 0 ; to skip the chars simply use negatives for n
      s + Chr(c)
      If c=#LF And Right(s,2)=#CRLF$
        s + indent
        comment=0
      EndIf
    EndIf
    off+#soc
    temp_ = temp_ - 1 + 2*(0 Or temp_<0)
    c = PeekC(*mem+off)
    If (off/#soc) > len
      RETURN_(s)
    EndIf
    ;Debug Chr(c)
    If WindowEvent()=#PB_Event_CloseWindow
      End
    EndIf
  Wend
EndMacro


Macro findnext(s, ship=1, stopat=-1)
  While Not findhere(s,0,Len(s))
    shipnext(ship)
  Wend
  If stopat=-1
    shipnext(ship*Len(s))
  EndIf
EndMacro


Procedure isIncluded(file.s)
  ForEach parseFile_includes()
    If parseFile_includes() = file
      ProcedureReturn 1
    EndIf
  Next
  ProcedureReturn 0
EndProcedure


Procedure.s parseFile(file.s)
  Shared parseFile_includes()
  
  Static call.l
  call + 1
  If call = 1
    ClearList(parseFile_includes())
    parseFileError = "OK"
  EndIf
  
  Protected f, len, *mem, off, temp_
  Protected s.s, c.c, incname.s, incpath.s, s2.s, indent.s
  Protected xinc, comment, dquote
  
  If call>1
    s = LSet("",8," ")
  EndIf
  indent = LSet("",(call-1)*8," ")
  
  ; ------ READ
  f = ReadFile(#PB_Any,file)
  If f
    ;ReadStringFormat(0)
    len = Lof(f)
    *mem = AllocateMemory(len)
    If *mem
      ReadData(f, *mem, len)
      CloseFile(f)
      ; ------ EDIT
      incpath = GetPathPart(file)
      c = PeekC(*mem+off)
      While 1
        If dquote ;{
          If findhere(#DQUOTE$,0,2)
            dquote=0
            shipnext()
          Else
            shipnext() ; (default)
          EndIf
          ;}
        ElseIf comment ;{
          If findhere(#CRLF$)
            comment=0
            shipnext(2)
          ElseIf findhere("[merge_off]")
            s + "[...]"
            findnext("[merge_on]",-1)
            findnext(#CRLF$)
          ElseIf findhere("[merge_end]")
            s + "[...]"
            RETURN_(s)
          Else
            shipnext() ; (default)
          EndIf
          ;}
        Else ;{
          If findhere(#DQUOTE$,0,2)
            dquote=1
            shipnext()
          ElseIf And findhere(";",0,2)
            comment=1
            shipnext()
          ElseIf findhere("IncludePath")
            s + ";"
            
            incpath = ""
            shipnext(11)
            findnext(#DQUOTE$)
            While Not findhere(#DQUOTE$)
              incpath + Chr(c)
              shipnext()
            Wend
            findnext(#CRLF$)
            incpath = Trim(incpath)
            If Not Right(incpath,1) = "\"
              incpath + "\"
            EndIf
          ElseIf findhere("XIncludeFile") Or findhere("IncludeFile")
            xinc=findhere("X",0,2)
            s + ";"
            
            incname = ""
            shipnext( 11+xinc )
            findnext(#DQUOTE$)
            While Not findhere(#DQUOTE$)
              incname + Chr(c)
              shipnext()
            Wend
            findnext(#CRLF$)
            incname = Trim(incname)
            If Not FindString(incname,":",1) ; make relative paths absolute
              incname = incpath + incname
              ;findnext(#CRLF$,0,1)
            EndIf
            s + ";{ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\ " + incname + NEWLINE
            If xinc And isIncluded(incname)
              s + "; [file already included]" + NEWLINE
              
            Else
              AddElement(parseFile_includes())
              parseFile_includes() = incname
              s2 = parseFile(incname)
              If s2
                s + s2 + NEWLINE
              Else
                s + "; [error: " + ReplaceString(parseFileError,#CRLF$,NEWLINE+"; ") + "]" + NEWLINE
              EndIf
            EndIf
            s + ";}" + NEWLINE + ";  ________________________________/ [end] " + incname + NEWLINE + NEWLINE + NEWLINE
          Else
            shipnext() ; (default)
          EndIf
          ;}
        EndIf
      Wend
      FreeMemory(*mem)
    Else
      parseFileError = "allocating "+Str(len)+" bytes failed"
      RETURN_()
    EndIf
  Else
    parseFileError = "invalid file:" + #CRLF$ + file
    RETURN_()
  EndIf
  
  RETURN_(s)
EndProcedure


Procedure stringToFile(s.s, file.s)
  Protected f.l
  f = CreateFile(#PB_Any,file)
  If f
    WriteString(f,s)
    CloseFile(f)
    ProcedureReturn 1
  Else
    MessageRequester("", "can't create file:" + #CRLF$ + file)
    ProcedureReturn 0
  EndIf
EndProcedure



; ------ MAIN
Define file.s
Define s.s
Define outfile.s

If CountProgramParameters()
  file = ProgramParameter()
Else
  MessageRequester("", "drop a *.pb file")
  End
EndIf

;Debug GetCurrentDirectory()
;Debug file


OpenWindow(0,1,1,150,20,"merging...", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)

s = parseFile(file)
If s
  outfile = file+".OUT.pb"
  If stringToFile(s,outfile)
    ;RunProgram(outfile)
  EndIf
Else
  MessageRequester("error", "parseFile: "+#CRLF$+parseFileError)
  End
EndIf






; IDE Options = PureBasic 4.20 Beta 2 (Windows - x86)
; CursorPosition = 115
; FirstLine = 86
; Folding = --
; Executable = merge2.exe
; HideErrorLog
; CommandLine = E:\ProjectsPureBasic\_sgx\sgx_.pbi
; CompileSourceDirectory